package jp.co.sds_corp.util.jmx.naming;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.LinkRef;
import javax.naming.Name;
import javax.naming.NameNotFoundException;
import javax.naming.NamingException;

import jp.co.sds_corp.util.jmx.AbstractMBeanService;
import jp.co.sds_corp.util.jmx.IMBean;

public class NamingAlias extends AbstractMBeanService
		implements NamingAliasMBean
{
	private String fromName;
	private String toName;

	public NamingAlias() {
	}
	public NamingAlias(String fromName, String toName) {
	}

	public String getFromName() {
		return fromName;
	}
	public void setFromName(String name) throws NamingException {
		removeLinkRef(fromName);
		this.fromName = name;
		createLinkRef();        
	}
	public String getToName() {
		return toName;
	}
	public void setToName(String name) throws NamingException {
		this.toName = name;
		createLinkRef();
	}

	public String getName() {
		return "NamingAlias("+fromName+" -> "+toName+")";
	}
	public void startService() throws Exception {
		if( fromName == null ) {
			throw new IllegalStateException("fromName is null");
		}
		if( toName == null ) {
			throw new IllegalStateException("toName is null");
		}
		createLinkRef();
	}
	public void stopService() {
		try {
			removeLinkRef(fromName);
		} catch(Exception e) {
		}
	}

	private void createLinkRef() throws NamingException {
		if( super.getState() == IMBean.STARTING || super.getState() == IMBean.STARTED )
		{
			InitialContext ctx = new InitialContext();
			LinkRef link = new LinkRef(toName);
			Context fromCtx = ctx;
			Name name = ctx.getNameParser("").parse(fromName);
			String atom = name.get(name.size()-1);
			for(int n = 0; n < name.size()-1; n ++) {
				String comp = name.get(n);
				try {
					fromCtx = (Context) fromCtx.lookup(comp);
				} catch(NameNotFoundException e) {
					fromCtx = fromCtx.createSubcontext(comp);
				}
			}
			fromCtx.rebind(atom, link);
		}
	}
	private void removeLinkRef(String name) throws NamingException {
		if( super.getState() == IMBean.STARTED ) {
			InitialContext ctx = new InitialContext();
			ctx.unbind(name);
		}
	}
}
