package	jp.co.sds_corp.util.jmx.rmi;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.Set;

import javax.management.Attribute;
import javax.management.AttributeList;
import javax.management.AttributeNotFoundException;
import javax.management.InstanceAlreadyExistsException;
import javax.management.InstanceNotFoundException;
import javax.management.IntrospectionException;
import javax.management.InvalidAttributeValueException;
import javax.management.ListenerNotFoundException;
import javax.management.MBeanException;
import javax.management.MBeanInfo;
import javax.management.MBeanRegistrationException;
import javax.management.NotCompliantMBeanException;
import javax.management.NotificationFilter;
import javax.management.ObjectInstance;
import javax.management.ObjectName;
import javax.management.QueryExp;
import javax.management.ReflectionException;

public interface RMIConnector extends Remote
{
	public Object instantiate( String pClassName )
		throws ReflectionException, MBeanException, RemoteException;

	public Object instantiate( String pClassName, ObjectName pLoaderName )
		throws ReflectionException, MBeanException,
				InstanceNotFoundException, RemoteException;

	public Object instantiate( String pClassName, Object[] pParams,
								String[] pSignature )
		throws ReflectionException, MBeanException, RemoteException;

	public Object instantiate( String pClassName, ObjectName pLoaderName,
								Object[] pParams, String[] pSignature )
		throws ReflectionException, MBeanException,
				InstanceNotFoundException, RemoteException;

	public ObjectInstance createMBean( String pClassName, ObjectName pName )
		throws ReflectionException, InstanceAlreadyExistsException,
				MBeanRegistrationException, MBeanException,
				NotCompliantMBeanException, RemoteException;

	public ObjectInstance createMBean( String pClassName, ObjectName pName,
								ObjectName pLoaderName )
		throws ReflectionException, InstanceAlreadyExistsException,
				MBeanRegistrationException, MBeanException,
				NotCompliantMBeanException, InstanceNotFoundException,
				RemoteException;

	public ObjectInstance createMBean( String pClassName, ObjectName pName,
								Object[] pParams, String[] pSignature )
		throws ReflectionException, InstanceAlreadyExistsException,
				MBeanRegistrationException, MBeanException,
				NotCompliantMBeanException, RemoteException;

	public ObjectInstance createMBean( String pClassName, ObjectName pName,
								ObjectName pLoaderName, Object[] pParams,
								String[] pSignature )
		throws ReflectionException, InstanceAlreadyExistsException,
				MBeanRegistrationException, MBeanException,
				NotCompliantMBeanException, InstanceNotFoundException,
				RemoteException;

	public ObjectInstance registerMBean( Object pObject, ObjectName pName )
		throws InstanceAlreadyExistsException, MBeanRegistrationException,
				NotCompliantMBeanException, RemoteException;

	public void unregisterMBean( ObjectName pName )
		throws InstanceNotFoundException, MBeanRegistrationException,
				RemoteException;

	public ObjectInstance getObjectInstance( ObjectName pName )
		throws InstanceNotFoundException, RemoteException;

	public Set<ObjectInstance> queryMBeans( ObjectName pName, QueryExp pQuery )
		throws RemoteException;

	public Set<ObjectName> queryNames( ObjectName pName, QueryExp pQuery )
		throws RemoteException;

	public boolean isRegistered( ObjectName pName )
		throws RemoteException;

	public boolean isInstanceOf( ObjectName pName, String pClassName )
		throws InstanceNotFoundException, RemoteException;

	public Integer getMBeanCount()
		throws RemoteException;

	public Object getAttribute( ObjectName pName, String pAttribute )
		throws MBeanException, AttributeNotFoundException,
				InstanceNotFoundException, ReflectionException,
				RemoteException;

	public AttributeList getAttributes( ObjectName pName, String[] pAttributes )
		throws InstanceNotFoundException, ReflectionException, RemoteException;

	public void setAttribute( ObjectName pName, Attribute pAttribute )
		throws InstanceNotFoundException, AttributeNotFoundException,
				InvalidAttributeValueException, MBeanException,
				ReflectionException, RemoteException;

	public AttributeList setAttributes( ObjectName pName, AttributeList pAttributes )
		throws InstanceNotFoundException, ReflectionException, RemoteException;

	public Object invoke( ObjectName pName, String pActionName,
								Object[] pParams, String[] pSignature )
		throws InstanceNotFoundException, MBeanException,
				ReflectionException, RemoteException;

	public String getDefaultDomain()
		throws RemoteException;

	public void addNotificationListener( ObjectName pName,
						RMINotificationListener pListener,
						NotificationFilter pFilter, Object pHandback )
		throws InstanceNotFoundException, RemoteException;

	public void removeNotificationListener( ObjectName pName, RMINotificationListener pListener )
		throws InstanceNotFoundException, ListenerNotFoundException,
				RemoteException;

	public MBeanInfo getMBeanInfo( ObjectName pName )
		throws InstanceNotFoundException, IntrospectionException,
				ReflectionException, RemoteException;

}

